XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

Exam - My appliances

XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

The demo is available at the following url :
http://bemol.ddns.net

I - Requirement and launching

To be able to launch the program locally, you will need :
- JDK 11 
- Apache/nginx server 
- npm
- configured local port/ngrok or similar tool for tunnel

Unzipped the project.
Open a console/git batch in the following :
..\capgemini\capcodingexam\backend\exam
Execute :
./mvnw spring-boot:run
This will launch the backend. The default port is 8001.
You can check with ngrok that the backend is running by accessing the generated link with the following suffix :
http://X.ngrok.io/exam/swagger-ui/index.html
This will give access to the swagger.

Open a console/git batch in the following :
..\capgemini\capcodingexam\frontend\angular-bootstrap-exam
execute :
npm install
npm i -S bootstrap
npm start
This will launch the frontend.

II - Requirement interpetation and solutions.


*Searchable list of all recorded appliances
o Can be filtered using the provided search filters
 Serial Number
 Brand
 Model
 Status
 Date Bought

The list of all recorded appliances appears per default. A filter car allow to filter each column simultaneously and without needing to press a button.
Note : You will find a filter pipe unused in the code as it is one way to filter efficiently, however it doesn't allow to get the total number of records to show.
Instead, a filter component build a form which is sent to the main component when modified, the main component using then the filter to make the list of appliances respecting the different filters applied.

'Create a new record of my appliance not found in the list'

The user has the possibility to create a new appliance at all time using the + button at the bottom right of the screen.
However if a filter return no result (or if the list is empty), a button will appear and open the creation/update dialog, with prefilled field with the filter information

*System will show an error message if the same appliance is already found by identifying:
 Serial Number
 Brand
 Model

The error, or successful message, will appear at the bottom of the screen within the form of a snackBar (usefull and light alternative to show a message without opening a popup).
A unique key has been added to the triptic 'serial Number', 'Brand' and 'Model' but in term of Database, the Primary Key is an autogenerated incremental id as those informations must be editable.

*Update the details of an appliance
o Serial Number
o Brand
o Model
o Date Bought
o Status

As mentionned before, a unique key has been added to the triptic 'serial Number', 'Brand' and 'Model' but in term of Database, the Primary Key is an autogenerated incremental id as those informations must be editable.

*Remove old/unused/sold appliance from the list

As no exhaustiv list of values has been provided, i didn't defined an enum.
The delete button will appear only if the status is one of this 3 values.

*UI should be properly viewable in any devices (mobile, desktop, tablet, etc.)

Using angular and bootstrap with the use of sass function to get the value of a breakpoint in order to make the app full responsive.

III - Backend architecture and Miscellaneous

For the demo i choosed a simple Spring-boot/maven project, using Hibernate - JPA with H2 database for the persistancy.

The program use the following architecture :

Controller -> handling the API accessible for front (accessible through the configured swagger) 
Domain -> Handling entities
Service -> Handling JPA interfaces 
viewModel -> Handling Dto
mapper -> Handling mapping between DTO and entities.

An Abstract Entity containing columns that every entity should possess has been created (id and version).

JUnit tests has been used and be executed from AppTest class.

The tools folder at the root of the project contains a jar which is used to generate the angular services module so angular can call the backend APIs, using the Swagger.json obtained from the swagger-ui of the project.
